Title: Blog et pages perso au LIMOS
Date: 2017-05-24 10:20
Status: Published
Tags: python, pages perso, blog
Summary: Comment se créer sa page perso en utilisant éventuellement le moteur de blog pelican
Image: images/pelican/pelican.jpg

[TOC]

## Comment obtenir un espace web personnel?

Tout compte unix ayant un homedir sur le serveur de fichier **glouglou** peut se créer son espace web personnel en créant un répertoire ```public_html``` à la racine de son répertoire.

Tout le contenu de /home/path/to/username/public_html sera accessible via
* https://limos.isima.fr/~username
* https://fc.isima.fr/~username
* https://www.isima.fr/~username
* https://isima.fr/~username

## Comment faire ma page personnelle?

* tout seul
    * Si la solution ci-dessous vous êtes libre d'organiser votre espace web personnel comme bon vous semble: pour des raisons de sécurité privilégiez les sites statiques.
        * Si vous avez réellement besoin de traitements côté serveur, php est installé. Vous pouvez également bénéficer d'une base de données en effectuant une demande à [cri@isima.fr](mailto:cri@isima.fr)

* avec Pelican
    * Pelican est un module python qui permet à partir d'un code source (une arborescence de fichiers textes au format [markdown](https://github.com/adam-p/markdown-here/wiki/Markdown-Cheatsheet)) de générer des fichiers html statiques présentés dans une charte graphique fonctionnelle et unifiée.

> Cet article est consacré exclusivement à l'élaboration d'une page perso avec pelican!

### Prérequis

* [python](https://www.python.org/) >= 2.6 ([installation](http://www.mkdocs.org/#installing-python))
* [pip](https://pypi.python.org/pypi/pip) ([installation](https://pip.pypa.io/en/stable/installing/))
* [git](https://git-scm.com/) ([installation](https://git-scm.com/book/fr/v1/D%C3%A9marrage-rapide-Installation-de-Git))
* un éditeur de texte : [atom.io](https://atom.io/) est recommandé
* savoir ce qu'est [markdown](https://guides.github.com/features/mastering-markdown/)

### Installation de l'environnment

```shell
sudo pip install --editable .
```

> N.B. le '.' après --editable !!

> il est aussi possible d'installer ces modules python dans un virtualenv python afin de ne pas modifier la configuration de python sur votre système

### Récupérer son blog

* Le plus simple est probablement de forker [<i class="fa fa-gitlab" aria-hidden="true"></i> ce blog](https://gitlab.isima.fr/mazenovi/mazenod) (celui que vous êtes en train de lire)

[![fork pelican](images/pelican/fork-pelican.png)](images/pelican/fork-pelican.png)

* puis de cloner votre nouveau repo

```bash
git clone git@gitlab.isima.fr:username/blog.git
```

### Personnalisation

L'essentielle de la personnalisation du blog se fait dans le fichier ```pelicanconf.py``` à la racine du repo

Les principales options sont les suivantes

* ```AUTHOR``` : l'auteur du blog. En pratique c'est la chaîne de caractères qui sera affichée en pied de page de votre blog.
* ```SITENAME``` : le nom du site. En pratique cette chaîne de caractère est affichée dans l'en tête du site et dans les balises méta HTML qui servent notamment pour le référencement.
* ```SITELOGO``` le chemin vers l'image qui sera affichée dans l'en-tête du sites à (relativement au dossier ```content```)
* ```FAVICON ``` le chemin vers l'image affichée en [favicon](https://fr.wikipedia.org/wiki/Favicon) (relativement au dossier ```content```)
* ```LINKS``` et ```SOCIAL``` sont des tuples à 3 valeurs
    * première valeur le nom d'une icône issue de [http://fontawesome.io/icons/](http://fontawesome.io/icons/)
    * le libellé du lien
    * l'url vers la quelle pointera le lien
    ces listes de liens s'afficheront dans le menu de gauche
* ```CC_LICENSE```, ```CC_LICENSE_DERIVATIVES```, ```CC_LICENSE_COMMERCIAL``` et ```CUSTOM_LICENSE``` indiquent la licence de partage du contenu de votre page perso.
    * en savoir plus sur la [licence Creative Commons](https://fr.wikipedia.org/wiki/Licence_Creative_Commons)
    * choisir la bonne [licence Creative Commons](https://creativecommons.org/choose/)
    * [liste de licences de libre diffusion](https://fr.wikipedia.org/wiki/Licence_de_libre_diffusion#Liste_de_licences_de_libre_diffusion)
    les commentaires dans le fichier ```pelicanconf.py``` sont là pour vous aider
* ```DISQUS_SITENAME``` permet d'activer le service [disqus](https://disqus.com/) pour gérer les commentaires de votre blog
* ```DISPLAY_TAGS_ON_SIDEBAR``` permet d'afficher les tags utilisé dasnle menu de droite.
    * ```TAG_CLOUD_STEPS```, ```TAG_CLOUD_MAX_ITEMS``` ```TAG_CLOUD_BADGE``` permettent de personnaliser l'affichage des tags dasn la colonnes de droite

#### .gitlab-ci.yml

le fichier ```.gitlab-ci.yml``` permet d'automatiser la publication du contenu à chaque commit poussé sur le repository gitlab.

Pour l'utiliser vous devez simplement spécifier votre nom d'utilisateur et une clé ssh dans la partie variable du repository hébergeant votre page perso.

### Modifer ou ajouter du contenu à son espace personnel avec Pelican

Si vous venez de forker le repo vous devriez

#### Thèmes

Le thème LIMOS a été réalisé à partir du thème [pelican-bootstrap3](https://github.com/getpelican/pelican-themes/tree/master/pelican-bootstrap3)

* la version personnalisée limos est maintenu sur le repo
* si vous souhaitez mettre à jour votre thème il suffit de récupérer l'archive et de la décompressé dans le répertoire themes


### Coloration syntaxique

* [aperçus des thèmes pygment pour la coloration syntaxique](https://help.farbox.com/pygments.html)

### Equations mathématiques

### Table des matières

### Multi linguisme

### Quelques précisions techniques

#### Plugins

Les plugins pré installés sont

* [i18n_subsites](https://github.com/getpelican/pelican-plugins/tree/master/i18n_subsites) permet le multilinguisme complet du site
* [extract_toc]() qui permet la génération dynamique d'[ancres html](https://www.alsacreations.com/astuce/lire/5-lien-precis-page-ancre-anchor-diese.html) sur tous les titres (h1, h2, ...) et la génération automatique d'une table des matières pour les posts longs
* [math_render](https://github.com/getpelican/pelican-plugins/tree/master/render_math) permet d'insérer des forumles mathématique directement dans le corps des postets ou page
* [tipue_search](https://github.com/getpelican/pelican-plugins/tree/master/tipue_search) permet d'intégrer un moteur de recherche
* [tag_cloud](https://github.com/getpelican/pelican-plugins/tree/master/tag_cloud) permet de faire apparaître les tags et le nombre d'articles associés dans le menu de gauche
* à faire : [assets](https://github.com/getpelican/pelican-plugins/tree/master/assets) pour minifier et concaténer les fichiers css et js

### Librairies incluses

Ce blog intègre
* [fontawesome](http://fontawesome.io).
* [bootsrap3](http://getbootstrap.com/)
* [jquery v2.2.1](https://jquery.com/)
